var DetailsPage = 
{
    id: "contentsdp",
    url: "/content/",
    footerImg: "Images/DetailsPage/footer.png",
    enableNumberInput: true,
    response: "",
    contentType: "",
    contentId: "",
    videoId: "",
    interval: 3000,
    errorMessage: "{itemNameGC} {number} в {namePC} &laquo;{title}&raquo; "
                  + "не существует. Правее расположены все {itemNamePlural} "
                  + "({first}&mdash;{last}) по порядку."
};

DetailsPage.request = function(contentType, contentId)
{
    var url = DetailsPage.url + contentType + "/" + contentId;
    Main.request(url, DetailsPage.responseCallback);
    DetailsPage.contentId=contentId;
    DetailsPage.contentType=contentType;
};

DetailsPage.setVisible = function(visible)
{
    var v = visible ? "block" : "none";
    document.getElementById(DetailsPage.id).style.display = v;
    
    if (visible) {
        Main.setBreadcrumbs(DetailsPage.response.title);
        Main.setFooterImg(DetailsPage.footerImg);
        DetailsPage.timerId = setInterval(DetailsPage.spinImages, DetailsPage.interval);
    } else {
        clearInterval(DetailsPage.timerId);
    }
};

DetailsPage.responseCallback = function(data)
{
    DetailsPage.response = data;
    DetailsPage.init();
    DetailsPage.setStaticContent(); 
    DetailsPage.setDynamicContent();
    Main.setCurrentPage(DetailsPage);
    
    Utils.setImage(Utils.getByTag("dp_frame", "img"),
                   DetailsPage.response.videos[DetailsPage.ss_conter].image);
};

DetailsPage.init = function ()
{
    DetailsPage.ss_conter = 0; //slideshow counter
    DetailsPage.ep_pos = 0; //default episode    
    return true;
};
 
DetailsPage.setStaticContent = function()
{
    var coverNode = Utils.getById("dp_decor_logo");
    if (DetailsPage.response.coverArt) {
        coverNode.style.visibility = "visible";
        Utils.setImage(Utils.getByTag(coverNode, "img"),
                       DetailsPage.response.coverArt);
    }
    else {
        coverNode.style.visibility = "hidden";
    }

    Utils.putHtml(Utils.getById("dp_about"),
                  DetailsPage.response.fullDescription);
};
 
DetailsPage.spinImages=function()
{

    DetailsPage.ss_conter++;
    if (DetailsPage.ss_conter >= DetailsPage.response.videos.length) {
        DetailsPage.ss_conter = 0;
    }
    Utils.setImage(Utils.getByTag("dp_frame", "img"),
                   DetailsPage.response.videos[DetailsPage.ss_conter].image);
};

DetailsPage.setDynamicContent = function()
{
    var ep_list = DetailsPage.response.videos;
    
    for(var i=0; i<3; i++)
    {
        var ep_num = i + DetailsPage.ep_pos - 1;
        if (ep_num < 0)
        {
            Utils.addClass(Utils.getById("dp_cell_0"), "dp_hidden");
        }
        else if (ep_num > (ep_list.length - 1))
        {
            Utils.addClass(Utils.getById("dp_cell_2"), "dp_hidden");
        }
        else 
        {
            Utils.removeClass(Utils.getById("dp_cell_"+i), "dp_hidden");
            Utils.setImage(Utils.getByTag("dp_cell_"+i, "img"),
                           ep_list[ep_num].image);
            Utils.putHtml(Utils.getByTag("dp_cell_"+i, "h2"),
                          ep_list[ep_num].title);
            Utils.putHtml(Utils.getByTag("dp_cell_"+i, "span"),
                          ep_list[ep_num].number);
        }
    }

    // show error message
    if (DetailsPage.ep_pos < 0) {
        Utils.addClass(Utils.getById("dp_cell_1"), "error");
    }
    else {
        Utils.removeClass(Utils.getById("dp_cell_1"), "error");
    }
};

DetailsPage.onPanVolUp = function()
{
    DetailsPage.onRight();
};

DetailsPage.onPanVolDown = function()
{
    DetailsPage.onLeft();
};

DetailsPage.onPanChUp = function()
{
    DetailsPage.onUp();
};

DetailsPage.onPanChDown = function()
{
    DetailsPage.onDown();
};

DetailsPage.onRight = function()
{
    if (DetailsPage.ep_pos < DetailsPage.response.videos.length-1) {
        DetailsPage.ep_pos++;
        DetailsPage.setDynamicContent();
    }
};

DetailsPage.onLeft = function()
{
    if (DetailsPage.ep_pos > 0) {
        DetailsPage.ep_pos--;
        DetailsPage.setDynamicContent();
    }
};

DetailsPage.onEnter = function()
{
    if (DetailsPage.ep_pos >= 0) {
        var vid = DetailsPage.response.videos[DetailsPage.ep_pos].videoId;
        PlayerPage.request(DetailsPage.contentType, DetailsPage.contentId, vid);
    }
};

DetailsPage.onNumberInput = function(num)
{
    var videos = DetailsPage.response.videos;
    var found = false;

    for (var i = 0; i < videos.length; i++) {
        if (num == videos[i].number) {
            DetailsPage.ep_pos = i;
            found = true;
            break;
        }
    }

    if (!found) {
        DetailsPage.ep_pos = -1;

        var error = DetailsPage.errorMessage;
        error = error.replace("{title}", DetailsPage.response.title);
        error = error.replace("{namePC}", DetailsPage.response.contentNamePC);
        error = error.replace("{itemNameGC}",
                              Utils.capitalize(DetailsPage.response.itemNameGC));
        error = error.replace("{itemNamePlural}",
                              DetailsPage.response.itemNamePlural);
        error = error.replace("{number}", num);
        error = error.replace("{first}", videos[0].number);
        error = error.replace("{last}", videos[videos.length - 1].number);
        Utils.putHtml(Utils.getByTag("dp_cell_1", "p"), error);
    }

    DetailsPage.setDynamicContent();
};

DetailsPage.notifyStat = function(skipped)
{
    var statObj = {
        event_type: "page_view",
        event_info: "",
        content_type: DetailsPage.contentType,
        content_id: DetailsPage.contentId,
    };
    if (skipped) {
        statObj.event_info += "(ret)";
    }
    Stat.notify(statObj);
};
