var FirstPage = 
{
    config: {
        id: "fp-content",
        url: "/",
        columnsMax: 3,
        cellsMax: 3+1,
        footerImg: "Images/FirstPage/footer.png",
    },

    data: null,
    curColumnIdx: 1,
    curCellIdx: 1
};

FirstPage.request = function()
{
    Main.request(FirstPage.config.url, FirstPage.activate);
};

FirstPage.setVisible = function(visible)
{
    var v = visible ? "block" : "none";
    document.getElementById(FirstPage.config.id).style.display = v;

    if (visible) {
        Main.setFooterImg(FirstPage.config.footerImg);
    }
};

FirstPage.activate = function(data)
{
    FirstPage.data = data;
    FirstPage.showData();
    Main.debug("FP activated with " +data + data.stat);
    Stat.setNotifyUrl(data.stat);
    Main.setCurrentPage(FirstPage);
};

FirstPage.showData = function()
{
    var columns = FirstPage.data.menuColumns;

    for (var colIdx = 0; colIdx < columns.length; colIdx++)
    {
        if (colIdx >= FirstPage.config.columnsMax) {
            break;
        }
        var column = columns[colIdx];
        Utils.putHtml(Utils.getByTag("fp-col" + colIdx, "h1"), column.title);
        Utils.putHtml(Utils.getById("fp-footbtn" + colIdx), column.buttonTitle);

        for (var cellIdx = 0; cellIdx < column.menuItems.length; cellIdx++)
        {
            if (cellIdx >= FirstPage.config.cellsMax - 1) {
                break;
            }
            var item = column.menuItems[cellIdx];

            var domCell = Utils.getById("fp-cell" + colIdx + cellIdx);
            Utils.setImage(Utils.getByTag(domCell, "img"), item.image);
            Utils.putHtml(Utils.getByTag(domCell, "h2"), item.title);
            Utils.putHtml(Utils.getByTag(domCell, "p"), item.description);
        }
    }
};

FirstPage.setSelection = function(columnIdx, cellIdx)
{
    if (columnIdx < 0 || cellIdx < 0
        || columnIdx >= FirstPage.config.columnsMax
        || cellIdx >= FirstPage.config.cellsMax)
    {
        return;
    }

    var refreshImage = function(cellId)
    {
        var column = FirstPage.data.menuColumns[FirstPage.curColumnIdx];
        if (column.menuItems[FirstPage.curCellIdx]) {
            Utils.setImage(Utils.getByTag(cellId, "img"),
                           column.menuItems[FirstPage.curCellIdx].image);
        }
    }

    // removing selection from previous element
    var curCellId = "fp-cell" + FirstPage.curColumnIdx + FirstPage.curCellIdx;
    Utils.removeClass(Utils.getById(curCellId), "selected");
    refreshImage(curCellId);

    // set selection to new element
    FirstPage.curColumnIdx = columnIdx;
    FirstPage.curCellIdx = cellIdx;
    curCellId = "fp-cell" + FirstPage.curColumnIdx + FirstPage.curCellIdx;
    Utils.addClass(Utils.getById(curCellId), "selected");
    refreshImage(curCellId);
};

FirstPage.columnClicked = function(column)
{
    ListPage.request(column.contentType);
};

FirstPage.menuItemClicked = function(item)
{
    DetailsPage.request(item.contentType, item.contentId);
};

FirstPage.onLeft = function()
{
    FirstPage.setSelection(FirstPage.curColumnIdx - 1, FirstPage.curCellIdx);
};

FirstPage.onRight = function()
{
    FirstPage.setSelection(FirstPage.curColumnIdx + 1, FirstPage.curCellIdx);
};

FirstPage.onUp = function()
{
    FirstPage.setSelection(FirstPage.curColumnIdx, FirstPage.curCellIdx - 1);
};

FirstPage.onDown = function()
{
    FirstPage.setSelection(FirstPage.curColumnIdx, FirstPage.curCellIdx + 1);
};

FirstPage.onEnter = function()
{
    var column = FirstPage.data.menuColumns[FirstPage.curColumnIdx];

    if (FirstPage.curCellIdx == FirstPage.config.cellsMax - 1) {
        FirstPage.columnClicked(column);
    }
    else {
        var item = column.menuItems[FirstPage.curCellIdx];
        FirstPage.menuItemClicked(item);
    }
};

FirstPage.onPanVolUp = function()
{
    FirstPage.onRight();
};

FirstPage.onPanVolDown = function()
{
    FirstPage.onLeft();
};

FirstPage.onPanChDown = function()
{
    FirstPage.onDown();
};

FirstPage.onPanChDown = function()
{
    FirstPage.onUp();
};

FirstPage.onMenu = function()
{
    FirstPage.onEnter();
};

FirstPage.onGreen = function()
{
    
    var text = FirstPage.data.feedback;
    if (!text) {
        text = "С вопросами и пожеланиями <br>обращайтесь по e-mail: portal@smm.ru";
    }
    AlertPage.show(text, "Обратная связь", true);
};

FirstPage.notifyStat = function(skipped)
{
    var statObj = {
        event_type: "page_view",
        event_info: "first_page",
    };
    if (skipped) {
        statObj.event_info += "(ret)";
    }
    Stat.notify(statObj);


};
