var Server =
{
    XHRObj: null,
    networkError: "Ошибка доступа к серверу.\n"
                  + "Проверьте соединение с Интернетом.",
//                  + "Код ошибки: {code}",
    parseError: "Ошибка.\nПолучен некорректный ответ от сервера."
};

Server.init = function()
{
    Server.freeMemory();
    return true;
};

/* Saves memory according to samsung docs. */
Server.freeMemory = function()
{
    if (Server.XHRObj !== null)
    {
        Server.XHRObj.destroy();
        Server.XHRObj = null;
    }
};

/* Request data from url and returns JS-object as a single argument to
 * callback function. On error callback will be called with falsy
 * argument. */
Server.request = function(path, callback)
{
    var url = Main.config.apiUrl + path;
    url += "?app=" + Main.config.appName + "&version=" + Main.config.version;
    Main.debug("Requesting " + url);

    Server.freeMemory();
    Server.XHRObj = new XMLHttpRequest();

    Server.XHRObj.onreadystatechange = function()
    {
        if (Server.XHRObj.readyState == 4)
        {
            var data = false;

            if (Server.XHRObj.status != 200) {
                Main.debug("XHRObj.status: " + Server.XHRObj.status);
                Main.debug("XHRObj.statusText: " + Server.XHRObj.statusText);

                var msg = Server.networkError;//.replace("{code}",
                                             //         Server.XHRObj.status);
                Main.showError(msg);
                Server.freeMemory();
            }
            else {
                try {
                    data = JSON.parse(Server.XHRObj.responseText);
                }
                catch (e if e instanceof SyntaxError) {
                    Main.debug("JSON syntax error.");
                    Main.showError(Server.parseError);
                }
                finally {
                    Server.freeMemory();
                }
            }

            callback(data);
        }
    };

    Server.XHRObj.open("GET", url, true);
    Server.XHRObj.send();
};
