var Stat = {
    XHRObj : null,
    notifyUrl : "",
    deviceId : "",
    notifies : new Array(),
};

Stat.init = function() {
    Main.debug("testing Stat");
    if (Stat.XHRObj === null) {
        Stat.XHRObj = new XMLHttpRequest();
        Stat.XHRObj.onreadystatechange = function() {
            if (Stat.XHRObj.readyState === 4) {
                Main.debug(Stat.XHRObj.status);
                Stat.send();
            }
        }
    }
   return true;
};

Stat.setNotifyUrl = function(url) {
    Stat.notifyUrl = url;
};

Stat.initDeviceId = function() {
    if (Stat.deviceId)
        return;

    var NetworkPlugin = document.getElementById("pluginObjectNetwork");
    var NNaviPlugin = document.getElementById("pluginObjectNNavi");

    var DUID;
    var MAC;
    MAC = NetworkPlugin.GetMAC(1);
    DUID = NNaviPlugin.GetDUID(MAC);

    Main.debug("DUID - " + DUID);
    Stat.deviceId = DUID;

    //Main.debug("modelInfo - " + NNaviPlugin.GetModelCode());
};

Stat.notify = function(paramObj, customUrl) {
    if (customUrl) {
        Main.debug("Using custom URL");
        paramObj.url = customUrl;
    } else { 
        Main.debug("Using default URL");
        paramObj.url = Stat.notifyUrl;
    }

    Main.debug(paramObj.url);

    paramObj.session_key = Stat.deviceId;

    Stat.notifies.push(paramObj);

    Stat.send();

};

Stat.send = function() {
    if ((Stat.notifies.length === 0) || 
            ((Stat.XHRObj.readyState !== 4) &&
            (Stat.XHRObj.readyState !== 0))) {

        Main.debug("readyState - " + Stat.XHRObj.readyState);
        Main.debug("notifies len - " + Stat.notifies.length);
        Main.debug("bailing out");
        return;
    }
    Main.debug("about to send stat request");


    var paramObj = Stat.notifies.pop();
    var url = paramObj.url;
    delete paramObj.url;


    var params = new Array();
    for (var key in paramObj) {
        params.push(key + "=" + encodeURI(paramObj[key]));
    }

    var paramsStr = params.join("&");

    Main.debug("poped " + paramsStr);
    Main.debug("Url is " + url);

    if (!url) {
        Main.debug("url is " + url + " bailing out");
        setTimeout(Stat.send, 1000);
        return;
    }


    Stat.XHRObj.open("POST", url, true);
    Stat.XHRObj.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    Stat.XHRObj.setRequestHeader("Content-length", paramsStr.length);
    Stat.XHRObj.setRequestHeader("Connection", "close");
    Main.debug("Added request headers");
    Stat.XHRObj.send(paramsStr);
};

Stat.deinit = function() {
    if (Stat.XHRObj !== null) {
        Stat.XHRObj.destroy();
        Stat.XHRObj = null;
    }
};

